//############################################################################
//
// LaserBoy !!!
//
// by James Lehman
// Extra Stimulus Inc.
// james@akrobiz.com
//
// began: October 2003
//
//############################################################################
#ifndef __EZ_UAIL_COMMON_DEFINITIONS__
#define __EZ_UAIL_COMMON_DEFINITIONS__

//############################################################################
#include "ez_uail_macros.hpp"

//############################################################################
typedef unsigned long  u_long;
typedef unsigned int   u_int;
typedef unsigned short u_short;
typedef unsigned char  u_char;

//############################################################################
extern const double pi         ;
extern const double two_pi     ;
extern const double half_pi    ;
extern const double one_degree ; // in radians
extern const double one_radian ; // in degrees

//############################################################################
extern unsigned char byte_primes[55];

//############################################################################
//                        delta_02, delta_01, delta_12,
inline double delta_angle(double a, double b, double c) // sss triangle
{
    double angle;
    //------------------------------------------------------------------------
    if(    b == 0.0
        || c == 0.0
      )
        angle = 0;
    //------------------------------------------------------------------------
    else if(a == 0)
        angle = pi;
    //------------------------------------------------------------------------
    else if(a >= b + c)
        angle = 0;
    //------------------------------------------------------------------------
    else
        angle = pi - acos((b*b + c*c - a*a)/(2*b*c));
    //------------------------------------------------------------------------
    return angle;
}

//############################################################################
inline double simple_2D_angle(double x1, double y1, double x2, double y2)
{
    return atan2(y2 - y1, x2 - x1);
}

//############################################################################
static void SDL_bailout(int rc)
{
    SDL_Quit();
    exit(rc);
}

//############################################################################
float  ez_random_01               ();
float  ez_random_neg_to_pos_1     ();

//############################################################################
bool   get_dxf_pair (ifstream& in, int& group_code, string& entity_string);
//############################################################################
#endif

//############################################################################
//////////////////////////////////////////////////////////////////////////////
//############################################################################
